Bug 460846 - Deadlock possibility with nested LVMs with snapshots
Deadlock possibility with nested LVMs with snapshots
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity low
: rc
: ---
Assigned To: Mikulas Patocka
Martin Jenner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-09-01 18:20 EDT by Mikulas Patocka
Modified: 2009-01-20 15:17 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:17:25 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch (3.61 KB, patch)
2008-09-01 18:48 EDT, Mikulas Patocka
no flags Details | Diff

  None (edit)
Description Mikulas Patocka 2008-09-01 18:20:21 EDT
When using nested LVMs (volume group built from physical devices that are logical devices in another volume group), there is possibility of deadlock in snapshot target because it uses shared mempool. If the upper-layer LVM drains the mempool, the lower layer can deadlock unable to allocate any memory.

It nees to be changed to per-device mempools.

This deadlocky configuration is very unusual, but supported by Red Hat, so it should be fixed.
Comment 1 RHEL Product and Program Management 2008-09-01 18:22:05 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 2 Mikulas Patocka 2008-09-01 18:48:29 EDT
Created attachment 315497 [details]
patch

A patch for the problem. Use per-snapshot mempools.
Comment 3 Don Zickus 2008-09-11 15:44:20 EDT
in kernel-2.6.18-111.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 7 errata-xmlrpc 2009-01-20 15:17:25 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.